"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const advanced_options_tabs_1 = __importDefault(require("./advanced-options-tabs/advanced-options-tabs"));
const disabledOverlayStyles = (0, compass_components_1.css)({
    position: 'absolute',
    top: 0,
    bottom: -compass_components_1.spacing[1],
    left: -compass_components_1.spacing[1],
    right: -compass_components_1.spacing[1],
    backgroundColor: compass_components_1.compassUIColors.transparentWhite,
    zIndex: 1,
    cursor: 'not-allowed',
});
const connectionTabsContainer = (0, compass_components_1.css)({
    position: 'relative',
});
function AdvancedConnectionOptions({ disabled, errors, updateConnectionFormField, connectionOptions, }) {
    return (react_1.default.createElement(compass_components_1.Accordion, { text: "Advanced Connection Options" },
        react_1.default.createElement("div", { className: connectionTabsContainer },
            disabled && (react_1.default.createElement("div", { className: disabledOverlayStyles, title: "The connection form is disabled when the connection string cannot be parsed." })),
            react_1.default.createElement(advanced_options_tabs_1.default, { errors: errors, updateConnectionFormField: updateConnectionFormField, connectionOptions: connectionOptions }))));
}
exports.default = AdvancedConnectionOptions;
//# sourceMappingURL=advanced-connection-options.js.map