"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const mongodb_connection_string_url_1 = __importDefault(require("mongodb-connection-string-url"));
const general_tab_1 = __importDefault(require("./general-tab/general-tab"));
const authentication_tab_1 = __importDefault(require("./authentication-tab/authentication-tab"));
const proxy_and_ssh_tunnel_tab_1 = __importDefault(require("./ssh-tunnel-tab/proxy-and-ssh-tunnel-tab"));
const tls_ssl_tab_1 = __importDefault(require("./tls-ssl-tab/tls-ssl-tab"));
const advanced_tab_1 = __importDefault(require("./advanced-tab/advanced-tab"));
const validation_1 = require("../../utils/validation");
const default_connection_1 = require("../../constants/default-connection");
const tabsStyles = (0, compass_components_1.css)({
    marginTop: compass_components_1.spacing[1],
});
const tabWithErrorIndicatorStyles = (0, compass_components_1.css)({
    position: 'relative',
    '&::after': {
        position: 'absolute',
        top: -compass_components_1.spacing[2],
        right: -compass_components_1.spacing[2],
        content: '""',
        width: compass_components_1.spacing[2],
        height: compass_components_1.spacing[2],
        borderRadius: '50%',
        backgroundColor: compass_components_1.uiColors.red.base,
    },
});
function AdvancedOptionsTabs({ errors, updateConnectionFormField, connectionOptions, }) {
    const [activeTab, setActiveTab] = (0, react_1.useState)(0);
    const tabs = [
        { name: 'General', id: 'general', component: general_tab_1.default },
        {
            name: 'Authentication',
            id: 'authentication',
            component: authentication_tab_1.default,
        },
        { name: 'TLS/SSL', id: 'tls', component: tls_ssl_tab_1.default },
        { name: 'Proxy/SSH Tunnel', id: 'proxy', component: proxy_and_ssh_tunnel_tab_1.default },
        { name: 'Advanced', id: 'advanced', component: advanced_tab_1.default },
    ];
    const connectionStringUrl = (0, react_1.useMemo)(() => {
        try {
            return new mongodb_connection_string_url_1.default(connectionOptions.connectionString);
        }
        catch (e) {
            return new mongodb_connection_string_url_1.default(default_connection_1.defaultConnectionString);
        }
    }, [connectionOptions]);
    return (react_1.default.createElement(compass_components_1.Tabs, { className: tabsStyles, setSelected: setActiveTab, selected: activeTab, "aria-label": "Advanced Options Tabs" }, tabs.map((tabObject, idx) => {
        const TabComponent = tabObject.component;
        const tabErrors = (0, validation_1.errorsByFieldTab)(errors, tabObject.id);
        const showTabErrorIndicator = tabErrors.length > 0;
        return (react_1.default.createElement(compass_components_1.Tab, { key: idx, name: react_1.default.createElement("div", { className: (0, compass_components_1.cx)({
                    [tabWithErrorIndicatorStyles]: showTabErrorIndicator,
                }) }, tabObject.name), "aria-label": `${tabObject.name}${tabErrors.length > 0
                ? ` (${tabErrors.length} error${tabErrors.length > 1 ? 's' : ''})`
                : ''}`, "data-testid": `${tabObject.name}-tab`, "data-has-error": showTabErrorIndicator },
            react_1.default.createElement(TabComponent, { errors: errors, connectionStringUrl: connectionStringUrl, updateConnectionFormField: updateConnectionFormField, connectionOptions: connectionOptions })));
    })));
}
exports.default = AdvancedOptionsTabs;
//# sourceMappingURL=advanced-options-tabs.js.map