"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const read_preferences_1 = require("../../../utils/read-preferences");
const url_options_1 = __importDefault(require("./url-options"));
const infoButtonStyles = (0, compass_components_1.css)({
    verticalAlign: 'middle',
    marginTop: -compass_components_1.spacing[1],
});
const containerStyles = (0, compass_components_1.css)({
    marginTop: compass_components_1.spacing[3],
});
const fieldStyles = (0, compass_components_1.css)({
    width: '50%',
});
function AdvancedTab({ updateConnectionFormField, connectionStringUrl, }) {
    const { searchParams, pathname } = connectionStringUrl;
    const readPreference = searchParams.get('readPreference');
    const replicaSet = searchParams.get('replicaSet');
    const defaultDatabase = pathname.startsWith('/')
        ? pathname.substr(1)
        : pathname;
    const handleFieldChanged = (0, react_1.useCallback)((key, value) => {
        if (!value) {
            return updateConnectionFormField({
                type: 'delete-search-param',
                key,
            });
        }
        return updateConnectionFormField({
            type: 'update-search-param',
            currentKey: key,
            value,
        });
    }, [updateConnectionFormField]);
    const handlePathChanged = (0, react_1.useCallback)((value) => {
        return updateConnectionFormField({
            type: 'update-connection-path',
            value,
        });
    }, [updateConnectionFormField]);
    return (react_1.default.createElement("div", { className: containerStyles },
        react_1.default.createElement(compass_components_1.Label, { htmlFor: "read-preferences" },
            "Read Preference",
            react_1.default.createElement(compass_components_1.IconButton, { className: infoButtonStyles, "aria-label": "Read Preference Documentation", href: "https://docs.mongodb.com/manual/reference/connection-string/#read-preference-options", target: "_blank" },
                react_1.default.createElement(compass_components_1.Icon, { glyph: "InfoWithCircle", size: "small" }))),
        react_1.default.createElement(compass_components_1.RadioBoxGroup, { onChange: ({ target: { value } }) => {
                handleFieldChanged('readPreference', value);
            }, value: readPreference !== null && readPreference !== void 0 ? readPreference : '', "data-testid": "read-preferences", id: "read-preferences" }, read_preferences_1.readPreferences.map(({ title, id }) => {
            return (react_1.default.createElement(compass_components_1.RadioBox, { "data-testid": `${id}-preference-button`, checked: readPreference === id, value: id, key: id }, title));
        })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { spellCheck: false, className: fieldStyles, onChange: ({ target: { value } }) => {
                    handleFieldChanged('replicaSet', value);
                }, name: 'replica-set', "data-testid": 'replica-set', label: 'Replica Set Name', type: 'text', optional: true, value: replicaSet !== null && replicaSet !== void 0 ? replicaSet : '' })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { spellCheck: false, className: fieldStyles, onChange: ({ target: { value } }) => {
                    handlePathChanged(value);
                }, name: 'default-database', "data-testid": 'default-database', label: 'Default Authentication Database', type: 'text', optional: true, value: defaultDatabase !== null && defaultDatabase !== void 0 ? defaultDatabase : '', description: 'Authentication database used when authSource is not specified.' })),
        react_1.default.createElement(url_options_1.default, { connectionStringUrl: connectionStringUrl, updateConnectionFormField: updateConnectionFormField })));
}
exports.default = AdvancedTab;
//# sourceMappingURL=advanced-tab.js.map