"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const url_options_table_1 = __importDefault(require("./url-options-table"));
const urlOptionsContainerStyles = (0, compass_components_1.css)({
    marginTop: compass_components_1.spacing[3],
    width: '70%',
});
function UrlOptions({ updateConnectionFormField, connectionStringUrl, }) {
    return (react_1.default.createElement("div", { className: urlOptionsContainerStyles, "data-testid": "url-options" },
        react_1.default.createElement(compass_components_1.Label, { htmlFor: '' }, "Url Options"),
        react_1.default.createElement(compass_components_1.Description, null,
            "Add additional MongoDB url options to customize your connection.\u00A0",
            react_1.default.createElement(compass_components_1.Link, { href: 'https://docs.mongodb.com/manual/reference/connection-string/#connection-string-options' }, "Learn More")),
        react_1.default.createElement(url_options_table_1.default, { connectionStringUrl: connectionStringUrl, updateConnectionFormField: updateConnectionFormField })));
}
exports.default = UrlOptions;
//# sourceMappingURL=url-options.js.map