"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AWS_SESSION_TOKEN_LABEL = exports.AWS_SECRET_ACCESS_KEY_LABEL = exports.AWS_ACCESS_KEY_ID_LABEL = void 0;
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const connection_string_helpers_1 = require("../../../utils/connection-string-helpers");
exports.AWS_ACCESS_KEY_ID_LABEL = 'Aws Access Key Id';
exports.AWS_SECRET_ACCESS_KEY_LABEL = 'Aws Secret Access Key';
exports.AWS_SESSION_TOKEN_LABEL = 'Aws Session Token';
function AuthenticationAWS({ connectionStringUrl, updateConnectionFormField, }) {
    const awsAccessKeyId = (0, connection_string_helpers_1.getConnectionStringUsername)(connectionStringUrl);
    const awsSecretAccessKey = (0, connection_string_helpers_1.getConnectionStringPassword)(connectionStringUrl);
    const authMechanismProperties = (0, connection_string_helpers_1.parseAuthMechanismProperties)(connectionStringUrl);
    const sessionToken = authMechanismProperties.get('AWS_SESSION_TOKEN');
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    updateConnectionFormField({
                        type: 'update-username',
                        username: value,
                    });
                }, label: exports.AWS_ACCESS_KEY_ID_LABEL, value: awsAccessKeyId || '', optional: true })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    updateConnectionFormField({
                        type: 'update-password',
                        password: value,
                    });
                }, label: exports.AWS_SECRET_ACCESS_KEY_LABEL, type: "password", value: awsSecretAccessKey || '', optional: true })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    updateConnectionFormField({
                        type: 'update-auth-mechanism-property',
                        key: 'AWS_SESSION_TOKEN',
                        value: value,
                    });
                }, label: exports.AWS_SESSION_TOKEN_LABEL, value: sessionToken || '', optional: true, type: "password" }))));
}
exports.default = AuthenticationAWS;
//# sourceMappingURL=authentication-aws.js.map