"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PLAIN_PASSWORD_LABEL = exports.PLAIN_USERNAME_LABEL = void 0;
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const validation_1 = require("../../../utils/validation");
const connection_string_helpers_1 = require("../../../utils/connection-string-helpers");
exports.PLAIN_USERNAME_LABEL = 'Username';
exports.PLAIN_PASSWORD_LABEL = 'Password';
function AuthenticationPlain({ connectionStringUrl, updateConnectionFormField, errors, }) {
    const username = (0, connection_string_helpers_1.getConnectionStringUsername)(connectionStringUrl);
    const password = (0, connection_string_helpers_1.getConnectionStringPassword)(connectionStringUrl);
    const usernameError = (0, validation_1.errorMessageByFieldName)(errors, 'username');
    const passwordError = (0, validation_1.errorMessageByFieldName)(errors, 'password');
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    updateConnectionFormField({
                        type: 'update-username',
                        username: value,
                    });
                }, label: exports.PLAIN_USERNAME_LABEL, value: username || '', errorMessage: usernameError, state: usernameError ? 'error' : undefined })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    updateConnectionFormField({
                        type: 'update-password',
                        password: value,
                    });
                }, label: exports.PLAIN_PASSWORD_LABEL, type: "password", value: password || '', errorMessage: passwordError, state: passwordError ? 'error' : undefined }))));
}
exports.default = AuthenticationPlain;
//# sourceMappingURL=authentication-plain.js.map