"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const validation_1 = require("../../../utils/validation");
var MONGODB_SCHEMA;
(function (MONGODB_SCHEMA) {
    MONGODB_SCHEMA["MONGODB"] = "MONGODB";
    MONGODB_SCHEMA["MONGODB_SRV"] = "MONGODB_SRV";
})(MONGODB_SCHEMA || (MONGODB_SCHEMA = {}));
const descriptionStyles = (0, compass_components_1.css)({
    marginTop: compass_components_1.spacing[1],
});
const regularSchemaDescription = 'Standard Connection String Format. The standard format of the MongoDB connection URI is used to connect to a MongoDB deployment: standalone, replica set, or a sharded cluster.';
const srvSchemaDescription = 'DNS Seed List Connection Format. The +srv indicates to the client that the hostname that follows corresponds to a DNS SRV record.';
function SchemaInput({ connectionStringUrl, errors, updateConnectionFormField, }) {
    const { isSRV } = connectionStringUrl;
    const onChangeConnectionSchema = (0, react_1.useCallback)((event) => {
        updateConnectionFormField({
            type: 'update-connection-schema',
            isSrv: event.target.value === MONGODB_SCHEMA.MONGODB_SRV,
        });
    }, [updateConnectionFormField]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(compass_components_1.Label, { htmlFor: "connection-schema-radio-box-group" }, "Schema"),
        react_1.default.createElement(compass_components_1.RadioBoxGroup, { id: "connection-schema-radio-box-group", value: isSRV ? MONGODB_SCHEMA.MONGODB_SRV : MONGODB_SCHEMA.MONGODB, onChange: onChangeConnectionSchema },
            react_1.default.createElement(compass_components_1.RadioBox, { value: MONGODB_SCHEMA.MONGODB }, "mongodb"),
            react_1.default.createElement(compass_components_1.RadioBox, { value: MONGODB_SCHEMA.MONGODB_SRV }, "mongodb+srv")),
        react_1.default.createElement(compass_components_1.Description, { className: descriptionStyles }, isSRV ? srvSchemaDescription : regularSchemaDescription),
        (0, validation_1.fieldNameHasError)(errors, 'isSrv') && (react_1.default.createElement(compass_components_1.Banner, { variant: compass_components_1.BannerVariant.Danger }, (0, validation_1.errorMessageByFieldName)(errors, 'isSrv')))));
}
exports.default = SchemaInput;
//# sourceMappingURL=schema-input.js.map