"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const validation_1 = require("../../../utils/validation");
function Socks({ updateConnectionFormField, errors, connectionStringUrl, }) {
    var _a, _b, _c, _d;
    const typedSearchParams = connectionStringUrl.typedSearchParams();
    const handleFieldChanged = (0, react_1.useCallback)((key, value) => {
        if (!value) {
            return updateConnectionFormField({
                type: 'delete-search-param',
                key,
            });
        }
        return updateConnectionFormField({
            type: 'update-search-param',
            currentKey: key,
            value,
        });
    }, [updateConnectionFormField]);
    const fields = [
        {
            name: 'proxyHost',
            label: 'Proxy Hostname',
            type: 'text',
            optional: false,
            value: (_a = typedSearchParams.get('proxyHost')) !== null && _a !== void 0 ? _a : '',
            errorMessage: (0, validation_1.errorMessageByFieldName)(errors, 'proxyHostname'),
            state: (0, validation_1.fieldNameHasError)(errors, 'proxyHostname') ? 'error' : 'none',
        },
        {
            name: 'proxyPort',
            label: 'Proxy Tunnel Port',
            type: 'number',
            optional: true,
            value: (_b = typedSearchParams.get('proxyPort')) !== null && _b !== void 0 ? _b : '',
            state: 'none',
        },
        {
            name: 'proxyUsername',
            label: 'Proxy Username',
            type: 'text',
            optional: true,
            value: (_c = typedSearchParams.get('proxyUsername')) !== null && _c !== void 0 ? _c : '',
            state: 'none',
        },
        {
            name: 'proxyPassword',
            label: 'Proxy Password',
            type: 'password',
            optional: true,
            value: (_d = typedSearchParams.get('proxyPassword')) !== null && _d !== void 0 ? _d : '',
            state: 'none',
        },
    ];
    return (react_1.default.createElement(react_1.default.Fragment, null, fields.map(({ name, label, type, optional, value, errorMessage, state }) => (react_1.default.createElement(form_field_container_1.default, { key: name },
        react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                handleFieldChanged(name, value);
            }, name: name, "data-testid": name, label: label, type: type, optional: optional, value: value, errorMessage: errorMessage, state: state, spellCheck: false }))))));
}
exports.default = Socks;
//# sourceMappingURL=socks.js.map