"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const validation_1 = require("../../../utils/validation");
function SshTunnelIdentity({ sshTunnelOptions, updateConnectionFormField, errors, }) {
    var _a;
    const formFieldChanged = (0, react_1.useCallback)((key, value) => {
        return updateConnectionFormField({
            type: 'update-ssh-options',
            key,
            value,
        });
    }, [updateConnectionFormField]);
    const fields = [
        {
            name: 'host',
            label: 'SSH Hostname',
            type: 'text',
            optional: false,
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.host,
            errorMessage: (0, validation_1.errorMessageByFieldName)(errors, 'sshHostname'),
            state: (0, validation_1.fieldNameHasError)(errors, 'sshHostname') ? 'error' : 'none',
        },
        {
            name: 'port',
            label: 'SSH Tunnel Port',
            type: 'number',
            optional: false,
            value: (_a = sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.port) === null || _a === void 0 ? void 0 : _a.toString(),
            errorMessage: '',
            state: 'none',
        },
        {
            name: 'username',
            label: 'SSH Username',
            type: 'text',
            optional: false,
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.username,
            errorMessage: (0, validation_1.errorMessageByFieldName)(errors, 'sshUsername'),
            state: (0, validation_1.fieldNameHasError)(errors, 'sshUsername') ? 'error' : 'none',
        },
        {
            name: 'identityKeyFile',
            label: 'SSH Identity File',
            type: 'file',
            errorMessage: (0, validation_1.errorMessageByFieldName)(errors, 'sshIdentityKeyFile'),
            state: (0, validation_1.fieldNameHasError)(errors, 'sshIdentityKeyFile') ? 'error' : 'none',
            value: (sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.identityKeyFile) && sshTunnelOptions.identityKeyFile
                ? [sshTunnelOptions.identityKeyFile]
                : undefined,
        },
        {
            name: 'identityKeyPassphrase',
            label: 'SSH Passphrase',
            type: 'password',
            optional: true,
            value: sshTunnelOptions === null || sshTunnelOptions === void 0 ? void 0 : sshTunnelOptions.identityKeyPassphrase,
            errorMessage: undefined,
            state: 'none',
        },
    ];
    return (react_1.default.createElement(react_1.default.Fragment, null, fields.map(({ name, label, type, optional, value, errorMessage, state }) => {
        if (type === 'file') {
            return (react_1.default.createElement(form_field_container_1.default, { key: name },
                react_1.default.createElement(compass_components_1.FileInput, { id: name, dataTestId: name, onChange: (files) => {
                        formFieldChanged(name, files[0]);
                    }, label: label, error: Boolean(errorMessage), errorMessage: errorMessage, values: value, description: 'Learn More', link: 'https://mongodb.com' })));
        }
        return (react_1.default.createElement(form_field_container_1.default, { key: name },
            react_1.default.createElement(compass_components_1.TextInput, { onChange: ({ target: { value }, }) => {
                    formFieldChanged(name, value);
                }, name: name, "data-testid": name, label: label, type: type, optional: optional, value: value, errorMessage: errorMessage, state: state, spellCheck: false })));
    })));
}
exports.default = SshTunnelIdentity;
//# sourceMappingURL=ssh-tunnel-identity.js.map