"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const default_connection_1 = require("../../../constants/default-connection");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const ui_kit_context_1 = require("../../../contexts/ui-kit-context");
function Socks({ onConnectionOptionChanged, }) {
    const { TextInput } = (0, ui_kit_context_1.useUiKitContext)();
    const formFieldChanged = (key, value) => {
        onConnectionOptionChanged(key, value);
    };
    const fields = [
        {
            name: 'host',
            label: 'Proxy Hostname',
            type: 'text',
            optional: false,
            placeholder: 'Proxy Hostname',
            value: '',
            errorMessage: undefined,
            state: 'none',
        },
        {
            name: 'port',
            label: 'Proxy Tunnel Port',
            type: 'number',
            optional: false,
            placeholder: 'Proxy Tunnel Port',
            value: `${default_connection_1.defaultSocksPort}`,
            errorMessage: undefined,
            state: 'none',
        },
        {
            name: 'username',
            label: 'Proxy Username',
            type: 'text',
            optional: false,
            placeholder: 'Proxy Username',
            value: '',
            errorMessage: undefined,
            state: 'none',
        },
        {
            name: 'password',
            label: 'Proxy Password',
            type: 'password',
            optional: true,
            placeholder: 'Proxy Password',
            value: '',
            errorMessage: '',
            state: 'none',
        },
    ];
    return (react_1.default.createElement(react_1.default.Fragment, null, fields.map(({ name, label, type, optional, placeholder, value, errorMessage, state, }) => (react_1.default.createElement(form_field_container_1.default, { key: name },
        react_1.default.createElement(TextInput, { onChange: ({ target: { value }, }) => {
                formFieldChanged(name, name === 'port' ? Number(value) : value);
            }, name: name, "data-testid": name, label: label, type: type, optional: optional, placeholder: placeholder, value: value, errorMessage: errorMessage, state: state }))))));
}
exports.default = Socks;
//# sourceMappingURL=ssh-tunnel-socks.js.map