"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("../../form-field-container"));
const inputFieldStyles = (0, compass_components_1.css)({
    width: '80%',
});
function TLSClientCertificate({ connectionStringUrl, disabled, updateTLSClientCertificate, updateTLSClientCertificatePassword, }) {
    const typedParams = connectionStringUrl.typedSearchParams();
    const clientCertificateKeyFile = typedParams.get('tlsCertificateKeyFile');
    const tlsCertificateKeyFilePassword = typedParams.get('tlsCertificateKeyFilePassword');
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(form_field_container_1.default, { className: inputFieldStyles },
            react_1.default.createElement(compass_components_1.FileInput, { description: 'Learn More', disabled: disabled, id: "tlsCertificateKeyFile", label: "Client Certificate (.pem)", dataTestId: "tlsCertificateKeyFile-input", link: 'https://docs.mongodb.com/manual/reference/connection-string/#mongodb-urioption-urioption.tlsCertificateKeyFile', values: clientCertificateKeyFile ? [clientCertificateKeyFile] : [], onChange: (files) => {
                    updateTLSClientCertificate(files && files.length > 0 ? files[0] : null);
                }, showFileOnNewLine: true, optional: true, optionalMessage: "Optional (only required with X.509)" })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { className: inputFieldStyles, onChange: ({ target: { value }, }) => {
                    updateTLSClientCertificatePassword(value);
                }, disabled: disabled, "data-testid": "tlsCertificateKeyFilePassword-input", id: "tlsCertificateKeyFilePassword", label: "Client Key Password", type: "password", value: tlsCertificateKeyFilePassword || '', optional: true }))));
}
exports.default = TLSClientCertificate;
//# sourceMappingURL=tls-client-certificate.js.map