"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const validation_summary_1 = require("./validation-summary");
const formActionStyles = (0, compass_components_1.css)({
    borderTop: `1px solid ${compass_components_1.uiColors.gray.light2}`,
    paddingLeft: compass_components_1.spacing[4],
    paddingRight: compass_components_1.spacing[4],
});
const formButtonsStyles = (0, compass_components_1.css)({
    paddingTop: compass_components_1.spacing[3],
    paddingBottom: compass_components_1.spacing[3],
    textAlign: 'right',
});
function ConnectFormActions({ errors, warnings, onConnectClicked, }) {
    return (react_1.default.createElement("div", { className: formActionStyles },
        warnings.length ? react_1.default.createElement(validation_summary_1.WarningSummary, { warnings: warnings }) : '',
        errors.length ? react_1.default.createElement(validation_summary_1.ErrorSummary, { errors: errors }) : '',
        react_1.default.createElement("div", { className: formButtonsStyles },
            react_1.default.createElement(compass_components_1.Button, { variant: compass_components_1.ButtonVariant.Primary, onClick: onConnectClicked }, "Connect"))));
}
exports.default = ConnectFormActions;
//# sourceMappingURL=connect-form-actions.js.map