"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const lodash_1 = require("lodash");
const connection_string_input_1 = __importDefault(require("./connection-string-input"));
const advanced_connection_options_1 = __importDefault(require("./advanced-connection-options"));
const connect_form_actions_1 = __importDefault(require("./connect-form-actions"));
const use_connect_form_1 = require("../hooks/use-connect-form");
const validation_1 = require("../utils/validation");
const save_connection_modal_1 = __importDefault(require("./save-connection-modal"));
const formContainerStyles = (0, compass_components_1.css)({
    margin: 0,
    padding: 0,
    height: 'fit-content',
    width: 700,
    position: 'relative',
    display: 'inline-block',
});
const formCardStyles = (0, compass_components_1.css)({
    margin: 0,
    height: 'fit-content',
    width: '100%',
    position: 'relative',
    display: 'flex',
    flexFlow: 'column nowrap',
    maxHeight: '95vh',
});
const descriptionStyles = (0, compass_components_1.css)({
    marginTop: compass_components_1.spacing[2],
});
const formContentContainerStyles = (0, compass_components_1.css)({
    padding: compass_components_1.spacing[4],
    overflowY: 'auto',
    position: 'relative',
});
const formFooterStyles = (0, compass_components_1.css)({
    marginTop: 'auto',
});
const favoriteButtonStyles = (0, compass_components_1.css)({
    position: 'absolute',
    top: compass_components_1.spacing[2],
    right: compass_components_1.spacing[2],
    hover: {
        cursor: 'pointer',
    },
    width: compass_components_1.spacing[7],
    height: compass_components_1.spacing[7],
});
const favoriteButtonContentStyles = (0, compass_components_1.css)({
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'center',
    justifyContent: 'center',
});
const formHeaderStyles = (0, compass_components_1.css)({
    button: {
        visibility: 'hidden',
    },
    '&:hover': {
        button: {
            visibility: 'visible',
        },
    },
});
const editFavoriteButtonStyles = (0, compass_components_1.css)({
    verticalAlign: 'text-top',
});
const favoriteButtonLabelStyles = (0, compass_components_1.css)({
    paddingTop: compass_components_1.spacing[1],
    color: compass_components_1.uiColors.black,
    fontWeight: 'bold',
    fontSize: 12,
});
function ConnectForm({ initialConnectionInfo, connectionErrorMessage, onConnectClicked, onSaveConnectionClicked, }) {
    var _a, _b;
    const [{ enableEditingConnectionString, errors, warnings, connectionOptions }, { setEnableEditingConnectionString, updateConnectionFormField, setErrors },] = (0, use_connect_form_1.useConnectForm)(initialConnectionInfo, connectionErrorMessage);
    const [showSaveConnectionModal, setShowSaveConnectionModal] = (0, react_1.useState)(false);
    const connectionStringInvalidError = errors.find((error) => error.fieldName === 'connectionString');
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: formContainerStyles, "data-testid": "new-connect-form" },
            react_1.default.createElement(compass_components_1.Card, { className: formCardStyles },
                react_1.default.createElement("div", { className: formContentContainerStyles },
                    react_1.default.createElement(compass_components_1.H3, { className: formHeaderStyles }, (_b = (_a = initialConnectionInfo.favorite) === null || _a === void 0 ? void 0 : _a.name) !== null && _b !== void 0 ? _b : 'New Connection',
                        !!onSaveConnectionClicked && (react_1.default.createElement(compass_components_1.IconButton, { "aria-label": "Save Connection", className: editFavoriteButtonStyles, onClick: () => {
                                setShowSaveConnectionModal(true);
                            } },
                            react_1.default.createElement(compass_components_1.Icon, { glyph: "Edit" })))),
                    react_1.default.createElement(compass_components_1.Description, { className: descriptionStyles }, "Connect to a MongoDB deployment"),
                    !!onSaveConnectionClicked && (react_1.default.createElement(compass_components_1.IconButton, { "aria-label": "Save Connection", className: favoriteButtonStyles, size: "large", onMouseDown: (event) => {
                            event.preventDefault();
                        }, onClick: () => {
                            setShowSaveConnectionModal(true);
                        } },
                        react_1.default.createElement("div", { className: favoriteButtonContentStyles },
                            react_1.default.createElement(compass_components_1.FavoriteIcon, { isFavorite: !!initialConnectionInfo.favorite, size: compass_components_1.spacing[5] }),
                            react_1.default.createElement("span", { className: favoriteButtonLabelStyles }, "FAVORITE")))),
                    react_1.default.createElement(connection_string_input_1.default, { connectionString: connectionOptions.connectionString, enableEditingConnectionString: enableEditingConnectionString, setEnableEditingConnectionString: setEnableEditingConnectionString, updateConnectionFormField: updateConnectionFormField }),
                    connectionStringInvalidError && (react_1.default.createElement(compass_components_1.Banner, { variant: compass_components_1.BannerVariant.Danger }, connectionStringInvalidError.message)),
                    react_1.default.createElement(advanced_connection_options_1.default, { errors: connectionStringInvalidError ? [] : errors, disabled: !!connectionStringInvalidError, updateConnectionFormField: updateConnectionFormField, connectionOptions: connectionOptions })),
                react_1.default.createElement("div", { className: formFooterStyles },
                    react_1.default.createElement(connect_form_actions_1.default, { errors: connectionStringInvalidError ? [] : errors, warnings: connectionStringInvalidError ? [] : warnings, onConnectClicked: () => {
                            const updatedConnectionOptions = {
                                ...connectionOptions,
                            };
                            const formErrors = (0, validation_1.validateConnectionOptionsErrors)(updatedConnectionOptions);
                            if (formErrors.length) {
                                setErrors(formErrors);
                                return;
                            }
                            onConnectClicked({
                                ...initialConnectionInfo,
                                connectionOptions: updatedConnectionOptions,
                            });
                        } })))),
        !!onSaveConnectionClicked && (react_1.default.createElement(save_connection_modal_1.default, { open: showSaveConnectionModal, onCancelClicked: () => {
                setShowSaveConnectionModal(false);
            }, onSaveClicked: async (favoriteInfo) => {
                setShowSaveConnectionModal(false);
                try {
                    await onSaveConnectionClicked({
                        ...(0, lodash_1.cloneDeep)(initialConnectionInfo),
                        connectionOptions: (0, lodash_1.cloneDeep)(connectionOptions),
                        favorite: {
                            ...favoriteInfo,
                        },
                    });
                }
                catch (err) {
                    setErrors([err]);
                }
            }, key: initialConnectionInfo.id, initialFavoriteInfo: initialConnectionInfo.favorite }))));
}
exports.default = ConnectForm;
//# sourceMappingURL=connect-form.js.map