"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const form_field_container_1 = __importDefault(require("./form-field-container"));
const saved_connection_color_picker_1 = __importDefault(require("./saved-connection-color-picker"));
const connectionNameInputStyles = (0, compass_components_1.css)({
    marginTop: compass_components_1.spacing[5],
});
function SaveConnectionModal({ initialFavoriteInfo, onCancelClicked, onSaveClicked, open, }) {
    const [editingFavorite, setEditingFavorite] = (0, react_1.useState)({
        name: '',
        ...initialFavoriteInfo,
    });
    return (react_1.default.createElement(compass_components_1.ConfirmationModal, { title: initialFavoriteInfo ? 'Edit favorite' : 'Save connection to favorites', open: open, onConfirm: () => {
            void onSaveClicked({
                ...editingFavorite,
            });
        }, onCancel: onCancelClicked, buttonText: "Save" },
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(compass_components_1.TextInput, { className: connectionNameInputStyles, spellCheck: false, onChange: ({ target: { value }, }) => {
                    setEditingFavorite({
                        ...editingFavorite,
                        name: value,
                    });
                }, label: "Name", value: editingFavorite.name })),
        react_1.default.createElement(form_field_container_1.default, null,
            react_1.default.createElement(saved_connection_color_picker_1.default, { hex: editingFavorite.color, onChange: (newColor) => {
                    setEditingFavorite({
                        ...editingFavorite,
                        color: newColor,
                    });
                } }))));
}
exports.default = SaveConnectionModal;
//# sourceMappingURL=save-connection-modal.js.map