"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useUiKitContext = exports.createUiKitContext = exports.UiKitComponents = void 0;
const react_1 = require("react");
const lodash_1 = require("lodash");
exports.UiKitComponents = [
    'Accordion',
    'Banner',
    'BannerVariant',
    'Button',
    'ButtonVariant',
    'Cell',
    'Checkbox',
    'compassUIColors',
    'ConfirmationModal',
    'css',
    'cx',
    'Description',
    'Icon',
    'IconButton',
    'InlineDefinition',
    'FileInput',
    'Label',
    'Link',
    'Option',
    'OptionGroup',
    'RadioBox',
    'RadioBoxGroup',
    'Row',
    'Select',
    'spacing',
    'Tab',
    'Table',
    'TableHeader',
    'Tabs',
    'TextArea',
    'TextInput',
    'Toggle',
    'uiColors'
];
let UiKitContext;
const createUiKitContext = (components) => {
    UiKitContext = (0, react_1.createContext)((0, lodash_1.pick)(components, exports.UiKitComponents));
    console.log('1----------------------');
    console.log(UiKitContext);
    console.log('----------------------');
    return UiKitContext;
};
exports.createUiKitContext = createUiKitContext;
const useUiKitContext = () => {
    if (!UiKitContext) {
        return;
    }
    return (0, react_1.useContext)(UiKitContext);
};
exports.useUiKitContext = useUiKitContext;
exports.default = UiKitContext;
//# sourceMappingURL=ui-kit-context.js.map