import type { AuthMechanism } from 'mongodb';
import type ConnectionStringUrl from 'mongodb-connection-string-url';
import type { ConnectionOptions } from 'mongodb-data-service';
import type { ConnectionFormError } from './validation';
export declare type UpdateAuthMechanismAction = {
    type: 'update-auth-mechanism';
    authMechanism: AuthMechanism | null;
};
export declare type UpdateUsernameAction = {
    type: 'update-username';
    username: string;
};
export declare type UpdatePasswordAction = {
    type: 'update-password';
    password: string;
};
export declare function getConnectionUrlWithoutAuth(connectionStringUrl: ConnectionStringUrl): ConnectionStringUrl;
export declare function handleUpdateAuthMechanism({ action, connectionStringUrl, connectionOptions, }: {
    action: UpdateAuthMechanismAction;
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
}): {
    connectionOptions: ConnectionOptions;
    errors?: ConnectionFormError[];
};
export declare function handleUpdateUsername({ action, connectionStringUrl, connectionOptions, }: {
    action: UpdateUsernameAction;
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
}): {
    connectionOptions: ConnectionOptions;
    errors?: ConnectionFormError[];
};
export declare function handleUpdatePassword({ action, connectionStringUrl, connectionOptions, }: {
    action: UpdatePasswordAction;
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
}): {
    connectionOptions: ConnectionOptions;
    errors?: ConnectionFormError[];
};
//# sourceMappingURL=authentication-handler.d.ts.map