"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkForInvalidCharacterInHost = void 0;
const invalidHostCharacterRegex = /[@/]/;
const invalidSrvHostnameCharacterRegex = /[:@,/]/;
function checkForInvalidCharacterInHost(host, isSRV) {
    const hostRegex = isSRV
        ? invalidSrvHostnameCharacterRegex
        : invalidHostCharacterRegex;
    const invalidCharacterInHost = hostRegex.exec(host);
    if (invalidCharacterInHost) {
        throw new Error(`Invalid character in host: '${invalidCharacterInHost[0]}'`);
    }
}
exports.checkForInvalidCharacterInHost = checkForInvalidCharacterInHost;
//# sourceMappingURL=check-for-invalid-character-in-host.js.map