"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setConnectionStringPassword = exports.setConnectionStringUsername = exports.getConnectionStringPassword = exports.getConnectionStringUsername = exports.tryToParseConnectionString = exports.parseAuthMechanismProperties = void 0;
const mongodb_connection_string_url_1 = __importStar(require("mongodb-connection-string-url"));
function parseAuthMechanismProperties(connectionString) {
    const searchParams = connectionString.typedSearchParams();
    const authMechanismPropertiesString = searchParams.get('authMechanismProperties');
    try {
        return new mongodb_connection_string_url_1.CommaAndColonSeparatedRecord(authMechanismPropertiesString);
    }
    catch (e) {
        return new mongodb_connection_string_url_1.CommaAndColonSeparatedRecord();
    }
}
exports.parseAuthMechanismProperties = parseAuthMechanismProperties;
function tryToParseConnectionString(connectionString) {
    try {
        const connectionStringUrl = new mongodb_connection_string_url_1.default(connectionString);
        return [connectionStringUrl, undefined];
    }
    catch (err) {
        return [undefined, err];
    }
}
exports.tryToParseConnectionString = tryToParseConnectionString;
function getConnectionStringUsername(connectionStringUrl) {
    return decodeURIComponent(connectionStringUrl.username);
}
exports.getConnectionStringUsername = getConnectionStringUsername;
function getConnectionStringPassword(connectionStringUrl) {
    return decodeURIComponent(connectionStringUrl.password);
}
exports.getConnectionStringPassword = getConnectionStringPassword;
function setConnectionStringUsername(connectionStringUrl, username) {
    const updated = connectionStringUrl.clone();
    updated.username = encodeURIComponent(username);
    return updated;
}
exports.setConnectionStringUsername = setConnectionStringUsername;
function setConnectionStringPassword(connectionStringUrl, password) {
    const updated = connectionStringUrl.clone();
    updated.password = encodeURIComponent(password);
    return updated;
}
exports.setConnectionStringPassword = setConnectionStringPassword;
//# sourceMappingURL=connection-string-helpers.js.map