"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryUpdateConnectionStringSchema = void 0;
const default_connection_1 = require("../constants/default-connection");
function updateConnectionStringToStandard(connectionStringUrl) {
    if (!connectionStringUrl.isSRV) {
        return connectionStringUrl;
    }
    const newConnectionStringUrl = connectionStringUrl.clone();
    newConnectionStringUrl.protocol = 'mongodb:';
    newConnectionStringUrl.hosts = [
        `${newConnectionStringUrl.hosts[0]}:${default_connection_1.defaultPort}`,
    ];
    return newConnectionStringUrl;
}
function updateConnectionStringToSRV(connectionStringUrl) {
    if (connectionStringUrl.isSRV) {
        return connectionStringUrl;
    }
    const newConnectionStringUrl = connectionStringUrl.clone();
    const newHost = newConnectionStringUrl.hosts.length > 0
        ? newConnectionStringUrl.hosts[0].substring(0, newConnectionStringUrl.hosts[0].indexOf(':') === -1
            ? undefined
            : newConnectionStringUrl.hosts[0].indexOf(':'))
        : default_connection_1.defaultHostname;
    newConnectionStringUrl.hosts = [newHost];
    newConnectionStringUrl.protocol = 'mongodb+srv:';
    const searchParams = newConnectionStringUrl.typedSearchParams();
    if (searchParams.get('directConnection')) {
        searchParams.delete('directConnection');
    }
    return newConnectionStringUrl;
}
function tryUpdateConnectionStringSchema(connectionStringUrl, setIsSrv) {
    if (!setIsSrv) {
        return updateConnectionStringToStandard(connectionStringUrl);
    }
    else {
        return updateConnectionStringToSRV(connectionStringUrl);
    }
}
exports.tryUpdateConnectionStringSchema = tryUpdateConnectionStringSchema;
//# sourceMappingURL=connection-string-schema.js.map