"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNextHost = void 0;
const default_connection_1 = require("../constants/default-connection");
function hostHasPortNumber(host) {
    return (host.includes(':') && !isNaN(Number(host.slice(host.indexOf(':') + 1))));
}
function getPortFromHostOrDefault(host) {
    if (hostHasPortNumber(host)) {
        return Number(host.slice(host.indexOf(':') + 1)) || 27017;
    }
    return default_connection_1.defaultPort;
}
function getNextHost(hosts, addAfterIndex) {
    if (hosts.length < 1) {
        return `${default_connection_1.defaultHostname}:${default_connection_1.defaultPort}`;
    }
    const hostToAddAfter = hosts[addAfterIndex];
    const hostname = hostToAddAfter.includes(':')
        ? hostToAddAfter.slice(0, hostToAddAfter.indexOf(':'))
        : hostToAddAfter;
    const port = getPortFromHostOrDefault(hostToAddAfter) + 1;
    return `${hostname || default_connection_1.defaultHostname}:${port}`;
}
exports.getNextHost = getNextHost;
//# sourceMappingURL=get-next-host.js.map