import type ConnectionStringUrl from 'mongodb-connection-string-url';
import type { ConnectionOptions } from 'mongodb-data-service';
import type { MongoClientOptions } from 'mongodb';
export declare type TLS_OPTIONS = 'DEFAULT' | 'ON' | 'OFF';
export declare type TLSOptionName = keyof Pick<MongoClientOptions, 'tlsCAFile' | 'tlsCertificateKeyFile' | 'tlsCertificateKeyFilePassword' | 'tlsInsecure' | 'tlsAllowInvalidHostnames' | 'tlsAllowInvalidCertificates'>;
export interface UpdateTlsAction {
    type: 'update-tls';
    tlsOption: TLS_OPTIONS;
}
export interface UpdateTlsOptionAction {
    type: 'update-tls-option';
    key: TLSOptionName;
    value?: string | null;
}
export declare function handleUpdateTls({ action, connectionStringUrl, connectionOptions, }: {
    action: UpdateTlsAction;
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
}): {
    connectionOptions: ConnectionOptions;
};
export declare function handleUpdateTlsOption({ action, connectionStringUrl, connectionOptions, }: {
    action: UpdateTlsOptionAction;
    connectionStringUrl: ConnectionStringUrl;
    connectionOptions: ConnectionOptions;
}): {
    connectionOptions: ConnectionOptions;
};
//# sourceMappingURL=tls-handler.d.ts.map