"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleUpdateTlsOption = void 0;
function handleUpdateTlsOption({ action, connectionStringUrl, connectionOptions, }) {
    const updatedConnectionString = connectionStringUrl.clone();
    const updatedSearchParams = updatedConnectionString.typedSearchParams();
    if (action.tlsOption === 'ON') {
        updatedSearchParams.delete('ssl');
        updatedSearchParams.set('tls', 'true');
    }
    else if (action.tlsOption === 'OFF') {
        updatedSearchParams.delete('ssl');
        updatedSearchParams.set('tls', 'false');
    }
    else if (action.tlsOption === 'DEFAULT') {
        updatedSearchParams.delete('ssl');
        updatedSearchParams.delete('tls');
    }
    return {
        connectionOptions: {
            ...connectionOptions,
            connectionString: updatedConnectionString.toString(),
        },
    };
}
exports.handleUpdateTlsOption = handleUpdateTlsOption;
//# sourceMappingURL=tls-options.js.map