import type { ConnectionOptions } from 'mongodb-data-service';
import ConnectionString from 'mongodb-connection-string-url';
export declare type FieldName = 'connectionString' | 'hostname' | 'hosts' | 'isSrv' | 'kerberosPrincipal' | 'password' | 'schema' | 'proxyHostname' | 'sshHostname' | 'sshIdentityKeyFile' | 'sshPassword' | 'sshUsername' | 'tls' | 'tlsCertificateKeyFile' | 'username';
export declare type TabId = 'general' | 'authentication' | 'tls' | 'proxy' | 'advanced';
declare type ConnectionFormErrorWithField = {
    fieldName: FieldName;
    fieldTab: TabId;
    fieldIndex?: number;
    message: string;
};
declare type ConnectionFormErrorWithoutField = {
    fieldName?: never;
    fieldTab?: never;
    fieldIndex?: never;
    message: string;
};
export declare type ConnectionFormError = ConnectionFormErrorWithField | ConnectionFormErrorWithoutField;
export interface ConnectionFormWarning {
    message: string;
}
export declare function errorsByFieldTab(errors: ConnectionFormError[], tabId: TabId): ConnectionFormError[];
export declare function errorMessageByFieldName(errors: ConnectionFormError[], fieldName: FieldName): string | undefined;
export declare function fieldNameHasError(errors: ConnectionFormError[], fieldName: FieldName): boolean;
export declare function errorMessageByFieldNameAndIndex(errors: ConnectionFormError[], fieldName: FieldName, fieldIndex: number): string | undefined;
export declare function validateConnectionOptionsErrors(connectionOptions: ConnectionOptions): ConnectionFormError[];
export declare function getConnectionString(connectionOptions: ConnectionOptions): ConnectionString;
export declare function isSecure(connectionString: ConnectionString): boolean;
export declare function validateConnectionOptionsWarnings(connectionOptions: ConnectionOptions): ConnectionFormWarning[];
export {};
//# sourceMappingURL=validation.d.ts.map